#include <stdlib.h>
#include <sys/ipc.h>
#include <stdio.h>
#include <sys/shm.h>
#include <unistd.h>
#include <string.h>
#include <errno.h>
#include <signal.h>
#include <sys/stat.h>

typedef struct {
	int countS;
	int countN;
} shared_sum_t;

static shared_sum_t *sharedsum;

int main(int argc, char *argv[]){
	//get termination time and convert it to int
	int clock = atoi(argv[0]);
	
	
			// SET UP SHARED MEM //
	key_t key = ftok("oss.c", 50);
	if(key == -1){
                perror("key generation failed:");
                return EXIT_FAILURE;
        }

	//attach to shared memory
        int shmid = shmget(key,sizeof(shared_sum_t),0666|IPC_CREAT);
	if ((shmid == -1) && (errno != EEXIST))
        	return -1;
        else{
               sharedsum = (shared_sum_t *) shmat(shmid,NULL,0);
                if (sharedsum == (void *)-1){
                        return -1;
                }
        }
        


	//calculate termination time
	int temp = sharedsum->countN;
	int temp2 = sharedsum->countS;
	int termination = clock + temp;
	if(termination>=1000000000){
		termination-=1000000000;
		temp2++;
	}

	
	//exit loop when termination time is reached
	while(1){
		if(sharedsum->countN >= termination && sharedsum->countS >= temp2){
			break;
		}
	}

	         
	//detach from shared memory  
	shmdt(sharedsum); 
            

        return 0;
}
